#include "simulator.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <kled.h>
#include <qtextedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <string>
#include <qfile.h>
#include <stdio.h>
#include <iostream>
#include <qmessagebox.h>
#include <fstream>

using namespace std;

int sz=0;
int p=0;
QString curhex;
static char porta[8];
static char portd[8];
static char porte[8];
static char portb[8];

int hexdata[10000];
bool b0=0;
bool b1=0;
int Working_register;
char address[3];
int array_index;
//string bin1,bin2,bin3;     bunu kapattim(ufuk)
//////////////   burayi ekliyorum (ufuk) ///////////
char binary1[8],binary2[8];
string bin1,bin2;
char bin3[8];
char carry;
int return_array[1000];
int gotoint = 1;
int gotolu = 0;
////////////////////////////////////////////////////
bool initiated=false;
regs bank01[256];
regs bank23[256];

void initregs()
{
initiated=true;
 int i;
 for (i=0; i<256; i++)
	{
	bank01[i].value=0;
	bank23[i].value=0;
	}

 bank01[0].name="indirect";
 bank01[1].name="TMR0";
 bank01[2].name="PCL";
 bank01[3].name="STATUS";
 bank01[4].name="FSR";
 bank01[5].name="PORTA";
 bank01[6].name="PORTB";
 bank01[7].name="PORTC";
 bank01[8].name="PORTD";
 bank01[9].name="PORTE";
 bank01[10].name="PCLATH";
 bank01[11].name="INTCON";
 bank01[12].name="PIR1";
 bank01[13].name="PIR2";
 bank01[14].name="TMR1L";
 bank01[15].name="TMR1H";
 bank01[16].name="T1CON";
 bank01[17].name="TMR2";
 bank01[18].name="T2CON";
 bank01[19].name="SSPBUF";
 bank01[20].name="SSPCON";
 bank01[21].name="CCPR1L";
 bank01[22].name="CCPR1H";
 bank01[23].name="CCP1CON";
 bank01[24].name="RCSTA";
 bank01[25].name="TXREG";
 bank01[26].name="RCREG";
 bank01[27].name="CCPR2L";
 bank01[28].name="CCPR2H";
 bank01[29].name="CCP2CON";
 bank01[30].name="ADRESH";
 bank01[31].name="ADDCON0";

for(i=32; i<128; i++)
	bank01[i].name = "";



 bank01[128].name="indirect";
 bank01[129].name="OPTION_REG";
 bank01[130].name="PCL";
 bank01[131].name="STATUS";
 bank01[132].name="FSR";
 bank01[133].name="TRISA";
 bank01[134].name="TRISB";
 bank01[135].name="TRISC";
 bank01[136].name="TRISD";
 bank01[137].name="TRISE";
 bank01[138].name="PCLATH";
 bank01[139].name="INTCON";
 bank01[140].name="PIE1";
 bank01[141].name="PIE2";
 bank01[142].name="PCON";

for(i=143; i<145; i++)
	bank01[i].name = "";

 bank01[145].name="SSPCON2";
 bank01[146].name="PR2";
 bank01[147].name="SSPADD";
 bank01[148].name="SSPSTAT";

for(i=149; i<152; i++)
	bank01[i].name = "";

 bank01[152].name="TXSTA";
 bank01[153].name="SPBRG";

for(i=154; i<158; i++)
	bank01[i].name = "";

 bank01[158].name="ADRESL";
 bank01[159].name="ADCON1";

for(i=160; i<256; i++)
	bank01[i].name= "";


 bank23[0].name="indirect";	
 bank23[1].name="TMR0";
 bank23[2].name="PCL";
 bank23[3].name="STATUS";
 bank23[4].name="FSR";
 bank23[6].name="PORTB";

for(i=7; i<10; i++)
	bank23[i].name="";

 bank23[10].name="PCLATH";
 bank23[11].name="INTCON";
 bank23[12].name="EEDATA";
 bank23[13].name="EEADR";
 bank23[14].name="EEDATH";
 bank23[15].name="EEADRH";

for(i=16; i<129; i++)
	bank23[i].name = "";


 bank23[129].name="OPTION_REG";
 bank23[130].name="PCL";
 bank23[131].name="STATUS";
 bank23[132].name="FSR";
 bank23[133].name="";
 bank23[134].name="TRISB";

for(i=135; i<138; i++)
	bank23[i].name="";
 bank23[138].name="PCLATH";
 bank23[139].name="INTCON";
 bank23[140].name="EECON1";
 bank23[141].name="EECON2";

for(i=142; i<256; i++)
	bank23[i].name="";

}

int addresstoint(char a, char b) 
{
 int result;
 int aa;
 int bb;
switch (a)
	{
	 case 'A':
	 case 'a': aa = 160;
		   break;
	 case 'B':
	 case 'b': aa = 176;
		   break;
	 case 'C':
	 case 'c': aa = 192;
		   break;
	 case 'D':
	 case 'd': aa = 208;
		   break;
	 case 'E':
	 case 'e': aa = 224;
		   break;
	 case 'F':
	 case 'f': aa = 240;
		   break;
	 default: aa = 16*(a-'0');
	}

switch (b)
	{
	 case 'A':
	 case 'a': bb = 10;
		   break;
	 case 'B':
	 case 'b': bb = 11;
		   break;
	 case 'C':
	 case 'c': bb = 12;
		   break;
	 case 'D':
	 case 'd': bb = 13;
		   break;
	 case 'E':
	 case 'e': bb = 14;
		   break;
	 case 'F':
	 case 'f': bb = 15;
		   break;
	 default: bb = b-'0';
	}	

result = aa + bb;

return result;

}

void tobinary(char *result, int value)
{ 
    if (value>=256) value -= 256; 
    result[7]=value/128 +'0';
    value=value%128;
    result[6]=value/64 + '0';
    value=value%64;
    result[5]=value/32 + '0';
    value=value%32;
    result[4]=value/16 + '0';
    value=value%16;
    result[3]=value/8 + '0';
    value=value%8;
    result[2]=value/4 + '0';
    value=value%4;
    result[1]=value/2 + '0';
    value=value%2;
    result[0]=value + '0';
    
}

////////////   benim tobinary function m biraz degisik oldugu icin tobinary2 olarak ekliyorum(ufuk) ////////
void tobinary2(int value)
{ 
    //string result;
    //result[9]='\0';              ///////////////////////    8 olcak sanirim 

    if (value>=256) value -= 256; 
    binary1[0]=value/128 + '0';
    value=value%128;
    binary1[1]=value/64 + '0';
    value=value%64;
    binary1[2]=value/32 + '0';
    value=value%32;
    binary1[3]=value/16 + '0';
    value=value%16;
    binary1[4]=value/8 + '0';
    value=value%8;
    binary1[5]=value/4 + '0';
    value=value%4;
    binary1[6]=value/2 + '0';
    value=value%2;
    binary1[7]=value + '0';
    
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////


///// returnarrayindex function  buraya ekliyorum (ufuk)  //////////
int returnarrayindex()
{
	int i;
	
	for(i=0;i<1000;i++)
	{
		if(return_array[i] == -1)
			break;
	}
	
	return i;
}


/////////////     bintodec i ekliyorum(ufuk)    ////////////
int bintodec(char * a)
{
	int i,j;
	int count=0;
	
	for(i=0,j=128;i<8;i++)
	{
		if(a[i]=='1')
		{
			count = count + j;
		}
		j = j / 2;
	}
	return count;
}
////////////////////////////////////////////////////////////

int hextodec(char a,char b)
{
	int result=0;
	if(b<='9')
	{
		result = b - '0';
	}
	if(b=='A')
		result = 10;
	if(b=='B')
		result = 11;
	if(b=='C')
		result = 12;
	if(b=='D')
		result = 13;
	if(b=='E')
		result = 14;
	if(b=='F')
		result = 15;
	
		
	if(a<='9')
	{
		result = result + (16*(a - '0'));
	}
	if(a=='A')
		result = result + (16*10);
	if(a=='B')
		result = result + (16*11);
	if(a=='C')
		result = result + (16*12);
	if(a=='D')
		result = result + (16*13);
	if(a=='E')
		result = result + (16*14);
	if(a=='F')
		result = result + (16*15);
		
	return result;	
					
}
/////   gotohextodec i ekliyorum (ufuk)  ////////
int gotohextodec(char a,char b,char c)
{
	int i,result;
	result = 0;
	
	i = hextodec(b,c);

	
	if(a == 'F')
	{	
		result = 1792;
	}
	if(a == 'E')
	{	
		result = 1536;
	}
	if(a == 'D')
	{	
		result = 1280;
	}
	if(a == 'C')
	{	
		result = 1024;
	}
	if(a == 'B')
	{	
		result = 768;
	}
	if(a == 'A')
	{	
		result = 512;
	}
	if(a == '9')
	{	
		result = 256;
	}
	
	result = result + i;
	return result;
	
}
/////////////////////////////////////////////////


/////   callhextodec i ekliyorum (ufuk)  ////////
int callhextodec(char a,char b,char c)
{
	int i,result;
	result = 0;
	
	i = hextodec(b,c);

	
	if(a == '7')
	{	
		result = 1792;
	}
	if(a == '6')
	{	
		result = 1536;
	}
	if(a == '5')
	{	
		result = 1280;
	}
	if(a == '4')
	{	
		result = 1024;
	}
	if(a == '3')
	{	
		result = 768;
	}
	if(a == '2')
	{	
		result = 512;
	}
	if(a == '1')
	{	
		result = 256;
	}
	
	result = result + i;
	return result;
	
}
/////////////////////////////////////////////////


//okuyup tek boyutlu arraya atyo. 
void hex()
{
        initiated=true;
   	int i,number_of_lines,n;
	QFile fp1(curhex);
	QFile fp2(curhex);
	char c;
	number_of_lines = 0;
	
	for(i=0;i<10000;i++)
		hexdata[i]=-1;
	
	fp1.open(IO_ReadOnly);

	while(1)
	{
	    	c=fp1.getch();
		if(c==-1) break;
		if(c==':')
		{
			number_of_lines++;
			continue;
		}
		if(c=='\n')
		{
			c=fp1.getch();
			if(c!=':')
				break;
			else
			{
				number_of_lines++;
				continue;
			}
		}
	}
	
	number_of_lines = number_of_lines - 2;
	
	fp1.close();
	
	
	fp2.open(IO_ReadOnly);

	
	while(1) // ilk sray attk
	{

		c=fp2.getch();	
		
		if(c=='\n')
			break;
				
		
	}

	n=0;
	
	int j=0;

	for(i=1;i<=number_of_lines;i++)
	{
	 int a=7;
	 c=fp2.getch(); 
	 if (c==':') a=8;
		
		for(j=0; j<a; j++)  // ?????(ufuk)
		c=fp2.getch();		

		while(1)
		{
			c=fp2.getch();
			if(c=='\n')
				break;
			else
			{
				n=0;
				while(hexdata[n]!=-1)
				{
					n++;
				}
				hexdata[n]=c;
			}
		}

		hexdata[n]=-1;	
		hexdata[n-1]=-1;
		
			
	}
		
	fp2.close();	

	while(hexdata[sz]!=-1)
	{

	sz++;
		
	}

	///////////  return_array i -1 ile dolduruyorum(ufuk) ////
	int uf;
	for(uf=0;uf<1000;uf++)
	{
		return_array[uf] = -1;
	}
	//////////////////////////////////////////////////////////
}



void hexfunc(int k)
{
	//printf("ufuk\n");
   
	int literal=0;
	//// buraya ekliyorum(ufuk) ///////////
	int j=0;
	int kyedek=0;

			if(hexdata[k+2]=='0')
			{
				/****** sifir ile baslayanlar ***/
				if(hexdata[k+3]=='0')
				{
					/**** ilk ikisi sifir olanlar ****/
					if(hexdata[k]=='0')
					{
						if(hexdata[k+1]=='9')
						{
							//printf("retfie\n");
							kyedek = k;
						}
						if(hexdata[k+1]=='8')
						{
							printf("return\n");
							
							j = returnarrayindex();
							kyedek = return_array[j-1];

							printf("kyedek=%d\n\n", kyedek);
							return_array[j-1] = -1;
						}
						if(hexdata[k+1]=='0')
						{
							printf("NOP\n");
							for(j=0;j<100;j++);
							kyedek = k;
						}
					}
					if(hexdata[k]=='6')
					{
						if(hexdata[k+1]=='3')
						{
							//printf("sleep\n");
							kyedek = k;
						}
						if(hexdata[k+1]=='0')
						{
							printf("NOP\n");
							for(j=0;j<100;j++);
							kyedek = k;
						}
						if(hexdata[k+1]=='4')
						{
							//printf("CLRWDT\n");
							kyedek = k;
						}
					}
					if(hexdata[k]>='8')
					{
						printf("movwf\n");
						if(b0==0)
						{
							if(b1==0)
							{
								address[0]='0';
							}
							if(b1)
							{
								address[0]='1';
							}
							if(hexdata[k]=='8')
							{
								//working_register degerini 0+hexdata[k+1] adresine aticaz.
								address[1]='0';
								address[2]=hexdata[k+1];

							}
							if(hexdata[k]=='9')
							{
								//working_register degerini 1+hexdata[k+1] adresine aticaz.
								address[1]='1';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='A')
							{
								//working_register degerini 2+hexdata[k+1] adresine aticaz.
								address[1]='2';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='B')
							{
								//working_register degerini 3+hexdata[k+1] adresine aticaz.
								address[1]='3';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='C')
							{
								//working_register degerini 4+hexdata[k+1] adresine aticaz.
								address[1]='4';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='D')
							{
								//working_register degerini 5+hexdata[k+1] adresine aticaz.
								address[1]='5';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='E')
							{
								//working_register degerini 6+hexdata[k+1] adresine aticaz.
								address[1]='6';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='F')
							{
								//working_register degerini 7+hexdata[k+1] adresine aticaz.
								address[1]='7';
								address[2]=hexdata[k+1];
							}
								
						}
						if(b0)
						{
							if(!b1)
							{
								address[0]='0';
							}
							if(b1)
							{
								address[0]='1';
							}
							address[1]=hexdata[k];
							address[2]=hexdata[k+1];
						}

						array_index = addresstoint(address[1], address[2]);
						if(address[0]=='0')
						{
							if(bank01[array_index].name == "PORTD")
								printf("PORTD = %d\n",Working_register);
							bank01[array_index].value = Working_register;
							if(array_index == 129)   //OPTION_REG
								bank23[array_index].value = Working_register;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = Working_register;
								bank01[130].value = Working_register;
								bank23[2].value = Working_register;
								bank23[130].value = Working_register;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = Working_register;
								bank01[131].value = Working_register;
								bank23[3].value = Working_register;
								bank23[131].value = Working_register;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = Working_register;
								bank01[132].value = Working_register;
								bank23[4].value = Working_register;
								bank23[132].value = Working_register;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = Working_register;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = Working_register;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = Working_register;
								bank01[138].value = Working_register;
								bank23[10].value = Working_register;
								bank23[138].value = Working_register;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = Working_register;
								bank01[139].value = Working_register;
								bank23[11].value = Working_register;
								bank23[139].value = Working_register;
							}
								
						}
						if(address[0]=='1')
						{
							bank23[array_index].value = Working_register;
							if(array_index == 129)
								bank01[array_index].value = Working_register;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = Working_register;
								bank01[130].value = Working_register;
								bank23[2].value = Working_register;
								bank23[130].value = Working_register;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = Working_register;
								bank01[131].value = Working_register;
								bank23[3].value = Working_register;
								bank23[131].value = Working_register;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = Working_register;
								bank01[132].value = Working_register;
								bank23[4].value = Working_register;
								bank23[132].value = Working_register;
							}
							if(array_index == 6)  //PORTB
								bank01[array_index].value = Working_register;
							if(array_index == 134)  //TRISB
								bank01[array_index].value = Working_register;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = Working_register;
								bank01[138].value = Working_register;
								bank23[10].value = Working_register;
								bank23[138].value = Working_register;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = Working_register;
								bank01[139].value = Working_register;
								bank23[11].value = Working_register;
								bank23[139].value = Working_register;
							}
						}
						
						kyedek = k;
						//movwf in sonu
						//burada simulation funtion working_register daki int degeri adresi address te olan register a
						//yazilarak cagrilacak.

						
					}

					if((hexdata[k]=='2')||(hexdata[k]=='4'))
					{
						if(hexdata[k+1]=='0')
						{
							printf("NOP\n");
							for(j=0;j<100;j++);
						}	
					kyedek = k; 	
					}
					/***** ilk ikisi sifir olanlarin sonu ****/
				}

				if(hexdata[k+3]=='1')
				{
					/*ilki sifir ikincisi 1 olanlar*/
					if(hexdata[k]>='8')
					{
						printf("CLRF\n");
						if(!b0)
						{
							if(!b1)
							{
								address[0]='0';
							}
							if(b1)
							{
								address[0]='1';
							}
							if(hexdata[k]=='8')
							{
								address[1]='0';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='9')
							{
								address[1]='1';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='A')
							{
								address[1]='2';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='B')
							{
								address[1]='3';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='C')
							{
								address[1]='4';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='D')
							{
								address[1]='5';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='E')
							{
								address[1]='6';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='F')
							{
								address[1]='7';
								address[2]=hexdata[k+1];
							}
						}
						if(b0)
						{
							if(!b1)
							{
								address[0]='0';
							}
							if(b1)
							{
								address[0]='1';
							}
							address[1]=hexdata[k];
							address[2]=hexdata[k+1];
						}
						
						array_index = addresstoint(address[1], address[2]);
						if(address[0]=='0')
						{
							printf("bank01 deyim\n");
							bank01[array_index].value = 0;
							if(array_index == 129)   //OPTION_REG
								bank23[array_index].value = 0;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = 0;
								bank01[130].value = 0;
								bank23[2].value = 0;
								bank23[130].value = 0;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = 0;
								bank01[131].value = 0;
								bank23[3].value = 0;
								bank23[131].value = 0;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = 0;
								bank01[132].value = 0;
								bank23[4].value = 0;
								bank23[132].value = 0;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = 0;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = 0;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = 0;
								bank01[138].value = 0;
								bank23[10].value = 0;
								bank23[138].value = 0;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = 0;
								bank01[139].value = 0;
								bank23[11].value = 0;
								bank23[139].value = 0;
							}
							
						}
						if(address[0]=='1')
						{
							//printf("bank23 deyim\n");
							bank23[array_index].value = 0;
							if(array_index == 129)   //OPTION_REG
								bank01[array_index].value = 0;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = 0;
								bank01[130].value = 0;
								bank23[2].value = 0;
								bank23[130].value = 0;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = 0;
								bank01[131].value = 0;
								bank23[3].value = 0;
								bank23[131].value = 0;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = 0;
								bank01[132].value = 0;
								bank23[4].value = 0;
								bank23[132].value = 0;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = 0;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = 0;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = 0;
								bank01[138].value = 0;
								bank23[10].value = 0;
								bank23[138].value = 0;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = 0;
								bank01[139].value = 0;
								bank23[11].value = 0;
								bank23[139].value = 0;
							}
						}

						tobinary2(bank01[3].value);
						binary1[5] = '1';
						
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);

						kyedek = k;

						// clrf in sonu
						// address te adresi bulunan register i sifirlayacaz ve simulatin function u cagiracaz.
					}
	
					if(hexdata[k]<='7')
					{
						
						printf("CLRW\n");
						Working_register = 0;

						tobinary2(bank01[3].value);
						binary1[5] = '1';
						
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);	

						kyedek = k;

						// working register i sifirliyorum
						// burada simulation function u cagirmamiza gerek olmaz sanirim.
						// o yuzden burada biraz beklemek icin "for loop" koyabiliriz.

					}

					/*ilki sifir ikincisi 1 olanlarin sonu*/
				}

				if(hexdata[k+3]=='2')
				{
					/*ilki 0 ikincisi 2 olanlar */
					printf("SUBWF\n");
						if(!b0)
						{
							if(!b1)
							{
								address[0]='0';
							}
							if(b1)
							{
								address[0]='1';
							}
							if(hexdata[k] < '8')
							{
								address[1]= hexdata[k];
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='8')
							{
								address[1]='0';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='9')
							{
								address[1]='1';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='A')
							{
								address[1]='2';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='B')
							{
								address[1]='3';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='C')
							{
								address[1]='4';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='D')
							{
								address[1]='5';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='E')
							{
								address[1]='6';
								address[2]=hexdata[k+1];
							}
							if(hexdata[k]=='F')
							{
								address[1]='7';
								address[2]=hexdata[k+1];
							}
						}
						if(b0)
						{
							if(!b1)
							{
								address[0]='0';
							}
							if(b1)
							{
								address[0]='1';
							}
							if(hexdata[k]>='8')
							{
								address[1]=hexdata[k];
							}
							if(hexdata[k]=='7')
							{
								address[1]='F';
							}
							if(hexdata[k]=='6')
							{
								address[1]='E';
							}
							if(hexdata[k]=='5')
							{
								address[1]='D';
							}
							if(hexdata[k]=='4')
							{
								address[1]='C';
							}
							if(hexdata[k]=='3')
							{
								address[1]='B';
							}
							if(hexdata[k]=='2')
							{
								address[1]='A';
							}
							if(hexdata[k]=='1')
							{
								address[1]='9';
							}
							if(hexdata[k]=='0')
							{
								address[1]='8';
							}
							
							address[2]=hexdata[k+1];
						}
						
						array_index = addresstoint(address[1], address[2]);
						
						if(address[0]=='0')
						{
						
							if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
							{
								//printf("subwf\n");
								bank01[array_index].value = bank01[array_index].value - Working_register;
								

								if(bank01[array_index].value > 0)
								{
									
									tobinary2(bank01[3].value);
									binary1[7] = '0';
									binary1[5] = '0';
								}
								if(bank01[array_index].value < 0)
								{
									
									tobinary2(bank01[3].value);
									binary1[7] = '1';
									binary1[5] = '0';
									
									bank01[array_index].value = bank01[array_index].value + 256;
									
								}
								if(bank01[array_index].value == 0)
								{
									
									tobinary2(bank01[3].value);
									binary1[5] = '1';
									
								}
								
								
								if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
								if((array_index == 2) || (array_index == 130))     // PCL
								{
									bank01[2].value = bank01[array_index].value;
									bank01[130].value = bank01[array_index].value;
									bank23[2].value = bank01[array_index].value;
									bank23[130].value = bank01[array_index].value;
								}
								if((array_index == 3)||(array_index == 131))    //STATUS
								{
									bank01[3].value = bank01[array_index].value;
									bank01[131].value = bank01[array_index].value;
									bank23[3].value = bank01[array_index].value;
									bank23[131].value = bank01[array_index].value;
								}
								if((array_index == 4)||(array_index == 132))    //FSR
								{
									bank01[4].value = bank01[array_index].value;
									bank01[132].value = bank01[array_index].value;
									bank23[4].value = bank01[array_index].value;
									bank23[132].value = bank01[array_index].value;
								}
								if(array_index == 6)   //PORTB
									bank23[array_index].value = bank01[array_index].value;
								if(array_index == 134)   //TRISB
									bank23[array_index].value = bank01[array_index].value;
								if((array_index == 10)||(array_index == 138))    //PCLATH
								{
									bank01[10].value = bank01[array_index].value;
									bank01[138].value = bank01[array_index].value;
									bank23[10].value = bank01[array_index].value;
									bank23[138].value = bank01[array_index].value;
								}
								if((array_index == 11)||(array_index == 139))    //INTCON
								{
									bank01[11].value = bank01[array_index].value;
									bank01[139].value = bank01[array_index].value;
									bank23[11].value = bank01[array_index].value;
									bank23[139].value = bank01[array_index].value;
								}
								
								
								
							}
							else				//destination=0 (working register a yazilacak)
							{
								//printf("subwf\n");
								Working_register = bank01[array_index].value - Working_register;
								if(Working_register > 0)
								{
									
									tobinary2(bank01[3].value);
									binary1[7] = '0';
									binary1[5] = '0';
								}
								if(Working_register < 0)
								{
								
									tobinary2(bank01[3].value);
									binary1[7] = '1';
									binary1[5] = '0';
									Working_register = Working_register + 256; 
								}
								if(Working_register == 0)
								{
								
									tobinary2(bank01[3].value);
									binary1[5] = '1';
								}
								
							}
							
							bank01[3].value = bintodec(binary1);
							bank01[131].value = bintodec(binary1);
							bank23[3].value = bintodec(binary1);
							bank23[131].value = bintodec(binary1);
							
						}
						if(address[0]=='1')
						{
							
							if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
							{
								bank23[array_index].value = bank23[array_index].value - Working_register;
								
								
								
								if(bank23[array_index].value > 0)
								{
									tobinary2(bank01[3].value);
									binary1[7] = '0';
									binary1[5] = '0';
								}
								if(bank23[array_index].value < 0)
								{
									tobinary2(bank01[3].value);
									binary1[7] = '1';
									binary1[5] = '0';
									bank23[array_index].value = bank23[array_index].value + 256;
								}
								if(bank23[array_index].value == 0)
								{
									tobinary2(bank01[3].value);
									binary1[5] = '1';
									
								}
								
								if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
								if((array_index == 2) || (array_index == 130))     // PCL
								{
									bank01[2].value = bank23[array_index].value;
									bank01[130].value = bank23[array_index].value;
									bank23[2].value = bank23[array_index].value;
									bank23[130].value = bank23[array_index].value;
								}
								if((array_index == 3)||(array_index == 131))    //STATUS
								{
									bank01[3].value = bank23[array_index].value;
									bank01[131].value = bank23[array_index].value;
									bank23[3].value = bank23[array_index].value;
									bank23[131].value = bank23[array_index].value;
								}
								if((array_index == 4)||(array_index == 132))    //FSR
								{
									bank01[4].value = bank23[array_index].value;
									bank01[132].value = bank23[array_index].value;
									bank23[4].value = bank23[array_index].value;
									bank23[132].value = bank23[array_index].value;
								}
								if(array_index == 6)   //PORTB
									bank01[array_index].value = bank23[array_index].value;
								if(array_index == 134)   //TRISB
									bank01[array_index].value = bank23[array_index].value;
								if((array_index == 10)||(array_index == 138))    //PCLATH
								{
									bank01[10].value = bank23[array_index].value;
									bank01[138].value = bank23[array_index].value;
									bank23[10].value = bank23[array_index].value;
									bank23[138].value = bank23[array_index].value;
								}
								if((array_index == 11)||(array_index == 139))    //INTCON
								{
									bank01[11].value = bank23[array_index].value;
									bank01[139].value = bank23[array_index].value;
									bank23[11].value = bank23[array_index].value;
									bank23[139].value = bank23[array_index].value;
								}
			
								
							}
							else				//destionation=0 (working register a yazilacak)
							{
								Working_register = bank23[array_index].value - Working_register;
								if(Working_register > 0)
								{
									tobinary2(bank01[3].value);
									binary1[7] = '0';
									binary1[5] = '0';
								}
								if(Working_register < 0)
								{
									tobinary2(bank01[3].value);
									binary1[7] = '1';
									binary1[5] = '0';
									Working_register = Working_register + 256; 
								}
								if(Working_register == 0)
								{
									tobinary2(bank01[3].value);
									binary1[5] = '1';
								}
								
							}
							bank01[3].value = bintodec(binary1);
							bank01[131].value = bintodec(binary1);
							bank23[3].value = bintodec(binary1);
							bank23[131].value = bintodec(binary1);
						}

					
				kyedek = k;
						
						
					/*ilki 0 ikincisi 2 olanlarin sonu*/
				}

				if(hexdata[k+3]=='3')
				{
					printf("DECF\n");
					if(!b1)
					{
						address[0]='0';
					}
					if(b1)
					{
						address[0]='1';
					}
					if(!b0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
						
					tobinary2(bank01[3].value);
					
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							if(bank01[array_index].value == 0)
							{
								bank01[array_index].value = 255;
							}
							else
							{
								bank01[array_index].value = bank01[array_index].value - 1;
								if(bank01[array_index].value == 0)
									binary1[5] = '1';
							}
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							if(bank01[array_index].value == 0)
							{
								Working_register = 255;
							}
							else
							{
								Working_register = bank01[array_index].value - 1;
								if(Working_register == 0)
									binary1[5] = '1';
							}
						}
					}
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							if(bank23[array_index].value == 0)
							{
								bank23[array_index].value = 255;
							}
							else
							{
								bank23[array_index].value = bank23[array_index].value - 1;
								if(bank23[array_index].value == 0)
									binary1[5] = '1';
							}
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
						}
						else				//destionation=0 (working register a yazilacak)
						{
							if(bank23[array_index].value == 0)
							{
								Working_register = 255;
							}
							else
							{
								Working_register = bank23[array_index].value - 1;
								if(Working_register == 0)
									binary1[5] = '1';
							}
						}
					}
					
					bank01[3].value = bintodec(binary1);
					bank01[131].value = bintodec(binary1);
					bank23[3].value = bintodec(binary1);
					bank23[131].value = bintodec(binary1);
					kyedek = k;
					
					
				}
				if(hexdata[k+3]=='4')
				{
					printf("IORWF\n");
					////////////////////////////////////     IORWF          ///////////////////////////////////
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{
						//tobinary (bank01[array_index].value);
						tobinary2(bank01[array_index].value);
						for(j=0;j<8;j++)
							binary2[j] = binary1[j];
					}
					if(address[0]=='1')
					{
						tobinary2 (bank23[array_index].value);
						for(j=0;j<8;j++)
							binary2[j] = binary1[j];
					}
					
					tobinary2 (Working_register);
					
					
					for(j=0;j<8;j++)
					{
						
						if((binary1[j]=='0')&&(binary2[j]=='0'))
						{
							bin3[j] = '0';
						}
						else
						{
							bin3[j] = '1';
						}
												
					}
					
					
					
					j = bintodec(bin3);

					if(j == 0)
					{
						tobinary2(bank01[3].value);
						binary1[5] = '1';
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);
					}
					
					
										
					if(address[0]=='0')
					{
						
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank01[array_index].value = j;
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
						}
						else				//destination=0 (working register a yazilacak)
						{
							Working_register = j;
						}
						
					}
					if(address[0]=='1')
					{
						
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank23[array_index].value = j;
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
						}
						else				//destionation=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
				kyedek = k;
				}

				if(hexdata[k+3]=='5')
				{
					printf("ANDWF\n");
					//////////////////////////////////////    ANDWF         ///////////////////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{
						
						tobinary2(bank01[array_index].value);
						for(j=0;j<8;j++)
							binary2[j] = binary1[j];
					}
					if(address[0]=='1')
					{
						tobinary2 (bank23[array_index].value);
						for(j=0;j<8;j++)
							binary2[j] = binary1[j];
					}
					
					tobinary2 (Working_register);
					
					
					for(j=0;j<8;j++)
					{
						
						if((binary1[j]=='1')&&(binary2[j]=='1'))
						{
							bin3[j] = '1';
						}
						else
						{
							bin3[j] = '0';
						}
						
						
					}
					
					
					
					j = bintodec(bin3);

					if(j == 0)
					{
						tobinary2(bank01[3].value);
						binary1[5] = '1';
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);
					}
					
						
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							//if(bank01[array_index].name == "PORTD")
							//	printf("PORTD = %d\n",j);
							bank01[array_index].value = j;
							
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							//if(bank23[array_index].name == "PORTD")
							//	printf("PORTD = %d\n",j);
							bank23[array_index].value = j;
							
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
						}
						else				//destionation=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					kyedek = k;
					
					/////////////////////////////////////     ANDWF        ////////////////////////////////////////
					
				}

				if(hexdata[k+3]=='6')
				{
					printf("XORWF\n");
					
					////////////////////////////////////      XORWF       //////////////////////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{
						//tobinary (bank01[array_index].value);
						tobinary2(bank01[array_index].value);
						for(j=0;j<8;j++)
							binary2[j] = binary1[j];
					}
					if(address[0]=='1')
					{
						tobinary2 (bank23[array_index].value);
						for(j=0;j<8;j++)
							binary2[j] = binary1[j];
					}
					
					tobinary2 (Working_register);
					
					
					for(j=0;j<8;j++)
					{
						
						if(binary1[j]==binary2[j])
						{
							bin3[j] = '0';
						}
						else
						{
							bin3[j] = '1';
						}
						
						
					}
					
					
					
					j = bintodec(bin3);
					
					if(j == 0)
					{
						tobinary2(bank01[3].value);
						binary1[5] = '1';
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);
					}
					
					
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank01[array_index].value = j;
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank23[array_index].value = j;
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
							
							
						}
						else				//destionation=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					kyedek = k;
					////////////////////////////////////      XORWF       //////////////////////////////////////////
				}
				if(hexdata[k+3]=='7')
				{
					printf("ADDWF\n");
					////////////////////           addwf     ////////////////////////
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
						
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank01[array_index].value = bank01[array_index].value + Working_register;
							if(bank01[array_index].value > 15)
							{
								tobinary2(bank01[3].value);
								binary1[5] = '0';
								binary1[6] = '1';
							}
							if(bank01[array_index].value == 0)
							{
								tobinary2(bank01[3].value);
								binary1[5] = '1';
							}
							if(bank01[array_index].value>=256)
							{
								tobinary2(bank01[3].value);
								binary1[7] = '1';
								binary1[5] = '0';
								bank01[array_index].value = bank01[array_index].value - 256;
							}
							
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
							
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							Working_register = bank01[array_index].value + Working_register;
							if(Working_register > 15)
							{
								tobinary2(bank01[3].value);
								binary1[6] = '1';
								binary1[5] = '0';
							}
							if(Working_register == 0)
							{
								tobinary2(bank01[3].value);
								binary1[5] = '1';
							}
							if(Working_register >= 256)
							{
								tobinary2(bank01[3].value);
								binary1[7] = '1';
								binary1[5] = '0';
								Working_register = Working_register - 256; 
							}
							
							
						}
					}
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank23[array_index].value = bank23[array_index].value + Working_register;
							
							if(bank23[array_index].value == 0)
							{
								tobinary2(bank01[3].value);
								binary1[5] = '1';
							}
							if(bank23[array_index].value > 15)
							{
								tobinary2(bank01[3].value);
								binary1[6] = '1';
								binary1[5] = '0';
							}
							if(bank23[array_index].value >= 256)
							{
								tobinary2(bank01[3].value);
								binary1[7] = '1';
								binary1[5] = '0';
								bank23[array_index].value = bank23[array_index].value - 256;
							}
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
							
							
							
						}
						else				//destionation=0 (working register a yazilacak)
						{
							Working_register = bank23[array_index].value + Working_register;
							
							if(Working_register == 0)
							{
								tobinary2(bank01[3].value);
								binary1[5] = '1';
							}
							if(Working_register > 15)
							{
								tobinary2(bank01[3].value);
								binary1[6] = '1';
								binary1[5] = '0';
							}
							if(Working_register >= 256)
							{
								tobinary2(bank01[3].value);
								binary1[7] = '1';
								binary1[5] = '0';
								Working_register = Working_register - 256; 
							}
						}
					}
					bank01[3].value = bintodec(binary1);	
					bank01[131].value = bintodec(binary1);
					bank23[3].value = bintodec(binary1);
					bank23[131].value = bintodec(binary1);	
					kyedek = k;
					
					////////////////           addwf          ///////////////////////////////
					
					
				}
				if(hexdata[k+3]=='8')
				{
					printf("MOVF\n");
					
					////////////////////     movf         ///////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
						
					tobinary2(bank01[3].value);
						
					if(address[0]=='0')
					{
						if(bank01[array_index].value == 0)
							binary1[5] = '1';
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank01[array_index].value = bank01[array_index].value;
							
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							Working_register = bank01[array_index].value;
						}
					}
					if(address[0]=='1')
					{
						if(bank23[array_index].value == 0)
							binary1[5] = '1';
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank23[array_index].value = bank23[array_index].value;
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
							
							
						}
						else				//destionation=0 (working register a yazilacak)
						{
							Working_register = bank23[array_index].value;
						}
					}	
					
					bank01[3].value = bintodec(binary1);
					bank01[131].value = bintodec(binary1);
					bank23[3].value = bintodec(binary1);
					bank23[131].value = bintodec(binary1);	
					kyedek = k;
					///////////////////      movf         ///////////////////////////
					
					
				}
				if(hexdata[k+3]=='9')
				{
					printf("COMF\n");
					/////////////////     comf               ////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{
						tobinary2(bank01[array_index].value);
					}
					if(address[0]=='1')
					{
						tobinary2(bank23[array_index].value);
					}
					
					for(j=0;j<8;j++)
					{
						if(binary1[j]=='1')
						{
							binary1[j]='0';
						}	
						else
						{
							binary1[j]='1';
						}
					}
					
					j = bintodec(binary1);

					if(j == 0)
					{
						tobinary2(bank01[3].value);
						binary1[5] = '1';
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);
					}
					
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank01[array_index].value = j;
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank23[array_index].value = j;
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
							
							
						}
						else				//destionation=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					
					////////////////      comf               ////////////////////////
					kyedek = k;
				}
				if(hexdata[k+3]=='A')
				{
					printf("INCF\n");
					/////////////////        incf         ///////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
						
					tobinary2(bank01[3].value);
						
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							if(bank01[array_index].value == 255)
							{
								binary1[5] = '1';
								bank01[array_index].value = 0; 
							}
							else
							{
								binary1[5] = '0';
								bank01[array_index].value = bank01[array_index].value + 1;
							}
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
							
							
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							if(bank01[array_index].value == 255)
							{
								binary1[5] = '1';
								Working_register = 0;
							}
							else
							{	
								binary1[5] = '0';
								Working_register = bank01[array_index].value + 1;
							}
							
							
						}
					}
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							if(bank23[array_index].value == 255)
							{
								binary1[5] = '1';
								bank23[array_index].value = 0;
							}
							else
							{
								binary1[5] = '0';
								bank23[array_index].value = bank23[array_index].value + 1;
							}
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
							
							
							
						}
						else				//destionation=0 (working register a yazilacak)
						{
							if(bank23[array_index].value == 255)
							{
								binary1[5] = '1';
								Working_register = 0;
							}
							else
							{
								binary1[5] = '0';
								Working_register = bank23[array_index].value + 1;
							}
						}
					}
					
					bank01[3].value = bintodec(binary1);
					bank01[131].value = bintodec(binary1);
					bank23[3].value = bintodec(binary1);
					bank23[131].value = bintodec(binary1);
					kyedek = k;
					////////////////         incf         //////////////////////////
					
					
				}
				if(hexdata[k+3]=='B')
				{
					
					printf("DECFSZ\n");
					
					///////////////////////      DECFSZ      ////////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
						
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							
							//printf(" %d\n",bank01[array_index].value);
							if(bank01[array_index].value == 0)
							{
								bank01[array_index].value = 255;
								kyedek = k;
							}
							else
							{
								bank01[array_index].value = bank01[array_index].value - 1;
						
								
								if(bank01[array_index].value == 0)            /////////// skip if zero
								{
									kyedek = k + 4;
								}
								if(bank01[array_index].value != 0)
								{
									kyedek = k;
								}
								
							}
							
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
							
													}
						else				//destination=0 (working register a yazilacak)
						{
							if(bank01[array_index].value == 0)
							{
								Working_register = 255;
								kyedek = k;
							}
							else
							{
								Working_register = bank01[array_index].value -1;
								
								if(Working_register == 0)                  ////////////// skip if zero
								{
									kyedek = k + 4;
								}
								if(Working_register != 0)
								{
									kyedek = k;
								}
							}
						}
					}
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							if(bank23[array_index].value == 0)
							{
								bank23[array_index].value = 255;
								kyedek = k;
							}
							else
							{
								bank23[array_index].value = bank23[array_index].value -1;
								
								if(bank23[array_index].value == 0)    /////////////////  skip if zero
								{
									kyedek = k + 4;
								}
								if(bank23[array_index].value != 0)
								{
									kyedek = k;
								}
							}
							
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
						
							
						}
						else				//destionation=0 (working register a yazilacak)
						{
							if(bank23[array_index].value == 0)
							{
								Working_register = 255;
								kyedek = k;
							}
							else
							{	
								Working_register = bank23[array_index].value - 1;
								
								if(Working_register == 0)          ////////////// skip if zero
								{
									kyedek = k + 4;
								}
								if(Working_register != 0)
								{
									kyedek = k;
								}
							}
							
						}
					}
					
					//////////////////////       DECFSZ      ///////////////////////////
				}
				if(hexdata[k+3]=='C')
				{
					printf("RRF\n");
					
					/////////////////////         RRF        ///////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{
						tobinary2(bank01[array_index].value);
					}
					if(address[0]=='1')
					{
						tobinary2(bank23[array_index].value);
					}
					
					for(j=0;j<8;j++)
						binary2[j] = binary1[j];
						
					tobinary2(bank01[3].value);  //// status register ini binary e ceviriyorum
					
					carry = binary1[7];     // statusun carry biti
					
					binary1[7] = binary2[7];  //// f in most significant bitini statusun carry bitine koyacam
					
					for(j=0;j<7;j++)
						bin3[j+1] = binary2[j];  ///// saga shift ediyorum
					
					bin3[0] = carry;
					
					j = bintodec(binary1); /// statusun value su
					
					bank01[3].value = j;
					bank01[131].value = j;
					bank23[3].value = j;
					bank23[131].value = j;
					
					j = bintodec(bin3);    /// rotate edilmis deger
					
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							if(bank01[array_index].name == "PORTD")
								printf("PORTD = %d\n",j);
							bank01[array_index].value = j;
							
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank23[array_index].value = j;
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
							
							
							
						}
						else				//destionation=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					kyedek = k;
					/////////////////////         RRF        ///////////////////////////
				}
				if(hexdata[k+3]=='D')
				{
					printf("RLF\n");
					
					////////////////////           RLF           ////////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{
						tobinary2(bank01[array_index].value);
					}
					if(address[0]=='1')
					{
						tobinary2(bank23[array_index].value);
					}
					
					for(j=0;j<8;j++)
						binary2[j] = binary1[j];
						
					tobinary2(bank01[3].value);  //// status register ini binary e ceviriyorum
					
					carry = binary1[7];     // statusun carry biti
					
					binary1[7] = binary2[0];  //// f in most significant bitini statusun carry bitine koyacam
					
					for(j=0;j<7;j++)
						bin3[j] = binary2[j+1];  ///// sola shift ediyorum
					
					bin3[7] = carry;
					
					j = bintodec(binary1); /// statusun value su
					
					bank01[3].value = j;
					bank01[131].value = j;
					bank23[3].value = j;
					bank23[131].value = j;
					
					j = bintodec(bin3);    /// rotate edilmis deger
					
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							if(bank01[array_index].name == "PORTD")
								printf("PORTD = %d\n",j);
							bank01[array_index].value = j;
							
							
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank23[array_index].value = j;
							
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
							
							
							
						}
						else				//destionation=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					kyedek = k;
					///////////////////            RLF           ////////////////////////////
				}
				
				if(hexdata[k+3]=='E')
				{
					printf("SWAPF\n");
					
					////////////////////////           SWAPF            //////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{
						//tobinary (bank01[array_index].value);
						tobinary2(bank01[array_index].value);
					}
					if(address[0]=='1')
					{
						tobinary2 (bank23[array_index].value);
					}
					
					bin3[0] = binary1[4];
					bin3[1] = binary1[5];
					bin3[2] = binary1[6];
					bin3[3] = binary1[7];
					bin3[4] = binary1[0];
					bin3[5] = binary1[1];
					bin3[6] = binary1[2];
					bin3[7] = binary1[3];
					
					
					j = bintodec(bin3);
					
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank01[array_index].value = j;
							
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
							
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					}
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							bank23[array_index].value = j;
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
							
							
							
						}
						else				//destionation=0 (working register a yazilacak)
						{
							Working_register = j;
						}
					} 
					
					kyedek = k;
					////////////////////////           SWAPF            /////////////////
				}
				if(hexdata[k+3]=='F')
				{
					printf("INCFSZ\n");
					
					///////////////////////             INCFSZ            ////////////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
						
					if(address[0]=='0')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							if(bank01[array_index].value == 255 )
							{
								bank01[array_index].value = 0;
								kyedek = k + 4;
							}
							else
							{
								bank01[array_index].value = bank01[array_index].value + 1;
								kyedek = k;
							}
							
							
							if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
							
							
							
						}
						else				//destination=0 (working register a yazilacak)
						{
							if(bank01[array_index].value == 255)
							{
								Working_register = 0;
								kyedek = k + 4;
							}
							else
							{
								Working_register = bank01[array_index].value + 1;
								kyedek = k;
							}
						}
					}
					
					if(address[0]=='1')
					{
						if(hexdata[k]>='8')		// destination=1 (register a yazilacak)
						{
							if(bank23[array_index].value == 255)
							{
								bank23[array_index].value = 0;
								kyedek = k + 4;
							}
						
							else
							{
								bank23[array_index].value = bank23[array_index].value + 1;
								kyedek = k;
							}
							
							
							
							if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
							
							
							
							
						}
						else				//destionation=0 (working register a yazilacak)
						{
							if(bank23[array_index].value == 255)
							{
								Working_register = 0;
								kyedek = k + 4;
							}
							else
							{	
								Working_register = bank23[array_index].value + 1;
								kyedek = k;
							}
						}
					}
					
					
				}


				/********** sifir ile baslayanlarin sonu *****/
				
			}
			if(hexdata[k+2]=='1')
			{
				/****** 1 ile baslayanlar *****/
				if(hexdata[k+3]<='3')
				{
					if((hexdata[k+3]=='3')&&(hexdata[k]=='0')&&(hexdata[k+1]=='3'))
					{
						b1=0;   /*RP1 is 0*/
					}
					if((hexdata[k+3]=='2')&&(hexdata[k]=='8')&&(hexdata[k+1]=='3'))
					{
						b0=0;   /* RP0 is 0 */
					}
					
					printf("BCF\n");
					
					//////////////////////       BCF        /////////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{
						tobinary2(bank01[array_index].value);
					}
					if(address[0]=='1')
					{
						tobinary2(bank23[array_index].value);
					}
					
					j=0;  ///// hangi biti clear yapacagimi bulmak icin j yi kullaniyorum
					
					if(hexdata[k]>='8')
					{
						j = j + 1;
					}
					if(hexdata[k+3]=='3')
					{
						j = j + 6;
					}
					if(hexdata[k+3]=='2')
					{
						j = j + 4;
					}
					if(hexdata[k+3]=='1')
					{
						j = j + 2;
					}
					////////   burada j integer i hangi biti clear yapacagimi tutuyor
					
					binary1[7-j] = '0';
					
					j = bintodec(binary1);   // clear ettikten sonra deegri j ye attim
					
					
					if(address[0]=='0')
					{
						bank01[array_index].value = j;
						
						if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
						
					}
					if(address[0]=='1')
					{
						bank23[array_index].value = j;
						
						
						if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
						
						
						
					}
					
					kyedek = k;
					
					/////////////////////        BCF        /////////////////////////////
					
					
				}
				if((hexdata[k+3]>='4')&&(hexdata[k+3]<'8'))
				{
					if((hexdata[k+3]=='6')&&(hexdata[k]=='8')&&(hexdata[k+1]=='3'))
					{
						b0=1;  /* RP0 is 1 */
					}
					if((hexdata[k+3]=='7')&&(hexdata[k]=='0')&&(hexdata[k+1]=='3'))
					{
						b1=1;  /* RP1 is 1 */
					}
					printf("BSF\n");
					
					
					///////////////////////////            BSF            ////////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{
						tobinary2(bank01[array_index].value);
					}
					if(address[0]=='1')
					{
						tobinary2(bank23[array_index].value);
					}
					
					j=0;  ///// hangi biti set edecegimi bulmak icin j yi kullaniyorum
					
					if(hexdata[k]>='8')
					{
						j = j + 1;
					}
					if(hexdata[k+3]=='7')
					{
						j = j + 6;
					}
					if(hexdata[k+3]=='6')
					{
						j = j + 4;
					}
					if(hexdata[k+3]=='5')
					{
						j = j + 2;
					}
					
					////////   burada j integer i hangi biti set edecegimi tutuyor
					
					binary1[7-j] = '1';
					
					j = bintodec(binary1);   // set ettikten sonra deegri j ye attim
					
					
					if(address[0]=='0')
					{
						bank01[array_index].value = j;
						
						if(array_index == 129)   //OPTION_REG
									bank23[array_index].value = bank01[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank01[array_index].value;
								bank01[130].value = bank01[array_index].value;
								bank23[2].value = bank01[array_index].value;
								bank23[130].value = bank01[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank01[array_index].value;
								bank01[131].value = bank01[array_index].value;
								bank23[3].value = bank01[array_index].value;
								bank23[131].value = bank01[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank01[array_index].value;
								bank01[132].value = bank01[array_index].value;
								bank23[4].value = bank01[array_index].value;
								bank23[132].value = bank01[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank23[array_index].value = bank01[array_index].value;
							if(array_index == 134)   //TRISB
								bank23[array_index].value = bank01[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank01[array_index].value;
								bank01[138].value = bank01[array_index].value;
								bank23[10].value = bank01[array_index].value;
								bank23[138].value = bank01[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank01[array_index].value;
								bank01[139].value = bank01[array_index].value;
								bank23[11].value = bank01[array_index].value;
								bank23[139].value = bank01[array_index].value;
							}
						
						
					}
					if(address[0]=='1')
					{
						bank23[array_index].value = j;
						
						
						if(array_index == 129)   //OPTION_REG
									bank01[array_index].value = bank23[array_index].value;
							if((array_index == 2) || (array_index == 130))     // PCL
							{
								bank01[2].value = bank23[array_index].value;
								bank01[130].value = bank23[array_index].value;
								bank23[2].value = bank23[array_index].value;
								bank23[130].value = bank23[array_index].value;
							}
							if((array_index == 3)||(array_index == 131))    //STATUS
							{
								bank01[3].value = bank23[array_index].value;
								bank01[131].value = bank23[array_index].value;
								bank23[3].value = bank23[array_index].value;
								bank23[131].value = bank23[array_index].value;
							}
							if((array_index == 4)||(array_index == 132))    //FSR
							{
								bank01[4].value = bank23[array_index].value;
								bank01[132].value = bank23[array_index].value;
								bank23[4].value = bank23[array_index].value;
								bank23[132].value = bank23[array_index].value;
							}
							if(array_index == 6)   //PORTB
								bank01[array_index].value = bank23[array_index].value;
							if(array_index == 134)   //TRISB
								bank01[array_index].value = bank23[array_index].value;
							if((array_index == 10)||(array_index == 138))    //PCLATH
							{
								bank01[10].value = bank23[array_index].value;
								bank01[138].value = bank23[array_index].value;
								bank23[10].value = bank23[array_index].value;
								bank23[138].value = bank23[array_index].value;
							}
							if((array_index == 11)||(array_index == 139))    //INTCON
							{
								bank01[11].value = bank23[array_index].value;
								bank01[139].value = bank23[array_index].value;
								bank23[11].value = bank23[array_index].value;
								bank23[139].value = bank23[array_index].value;
							}
						
					}
					kyedek = k;
					//////////////////////////             BSF            ///////////////////////
				}
				if((hexdata[k+3]>='8')&&(hexdata[k+3]<'C'))
				{
					printf("BTFSC\n");
					
					///////////////////////////           BTFSC           //////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{	
						tobinary2(bank01[array_index].value);
					}
					if(address[0]=='1')
					{
						tobinary2(bank23[array_index].value);
					}
					
					j=0;  ///// hangi biti kontrol edecegimi bulmak icin j yi kullaniyorum
					
					if(hexdata[k]>='8')
					{
						j = j + 1;
					}
					if(hexdata[k+3]=='B')
					{
						j = j + 6;
					}
					if(hexdata[k+3]=='A')
					{
						j = j + 4;
					}
					if(hexdata[k+3]=='9')
					{
						j = j + 2;
					}
					printf("hangi bit = %d\n",j);
					if(binary1[7-j] == '0')
					{
						printf("clearmis\n");
						kyedek = k + 4;	    //clear ise skip ediyorum.	
					}
					if(binary1[7-j] == '1')
					{
						printf("setmis\n");
						kyedek = k;
					}
					
					
					
					///////////////////////////           BTFSC           //////////////////////
				}
				if(hexdata[k+3]>='C')
				{
					printf("BTFSS\n");
					
					///////////////////////////           BTFSS           /////////////////////
					
					if(b1==0)
					{
						address[0]='0';
					}
					if(b1==1)
					{
						address[0]='1';
					}
					if(b0==0)
					{
						if(hexdata[k] < '8')
						{
							address[1]= hexdata[k];
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='8')
						{
							address[1]='0';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='9')
						{
							address[1]='1';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='A')
						{
							address[1]='2';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='B')
						{
							address[1]='3';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='C')
						{
							address[1]='4';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='D')
						{
							address[1]='5';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='E')
						{
							address[1]='6';
							address[2]=hexdata[k+1];
						}
						if(hexdata[k]=='F')
						{
							address[1]='7';
							address[2]=hexdata[k+1];
						}
					}
					if(b0==1)
					{
						if(hexdata[k]>='8')
						{
							address[1]=hexdata[k];
						}
						if(hexdata[k]=='7')
						{
							address[1]='F';
						}
						if(hexdata[k]=='6')
						{
							address[1]='E';
						}
						if(hexdata[k]=='5')
						{
							address[1]='D';
						}
						if(hexdata[k]=='4')
						{
							address[1]='C';
						}
						if(hexdata[k]=='3')
						{
							address[1]='B';
						}
						if(hexdata[k]=='2')
						{
							address[1]='A';
						}
						if(hexdata[k]=='1')
						{
							address[1]='9';
						}
						if(hexdata[k]=='0')
						{
							address[1]='8';
						}
						
						address[2]=hexdata[k+1];
					}
					
					array_index = addresstoint(address[1], address[2]);
					
					if(address[0]=='0')
					{
						tobinary2(bank01[array_index].value);
					}
					if(address[0]=='1')
					{
						tobinary2(bank23[array_index].value);
					}
					
					j=0;  ///// hangi biti kontrol edecegimi bulmak icin j yi kullaniyorum
					
					if(hexdata[k]>='8')
					{
						j = j + 1;
					}
					if(hexdata[k+3]=='F')
					{
						j = j + 6;
					}
					if(hexdata[k+3]=='E')
					{
						j = j + 4;
					}
					if(hexdata[k+3]=='D')
					{
						j = j + 2;
					}
					printf("hangi bit = %d\n",j);
					if(binary1[7-j] == '1')
					{
						printf("setmis\n");
						kyedek = k + 4;	    // set ise skip ediyorum.	
					}
					if(binary1[7-j] == '0')
					{
						printf("clearmis\n");
						kyedek = k;
					}
					
					
				}

				/****** 1 ile baslayanlarin sonu *****/
			}
			if(hexdata[k+2]=='2')
			{
				/***** 2 ile baslayanlar ****/
				if(hexdata[k+3]<'8')
				{
					printf("CALL\n");
					
					j=returnarrayindex();
					return_array[j] = k;
					
					j = callhextodec(hexdata[k+3],hexdata[k],hexdata[k+1]);
					
					if(gotolu==1)
					{
						kyedek = ((j-gotoint)*4) + 4; 
					}
					else
					{	
						kyedek = ((j-gotoint)*4) - 4;
						
					}
					printf("k=%d kyedek=%d\n\n", k, kyedek);
	
				}
				if(hexdata[k+3]>='8')
				{
					printf("GOTO\n");
					
					if(k==0)
					{
						gotolu = 1;
						gotoint = gotohextodec(hexdata[k+3],hexdata[k],hexdata[k+1]);
						kyedek = k;
					}
					if(k!=0)
					{
						j = gotohextodec(hexdata[k+3],hexdata[k],hexdata[k+1]);
						
						if(gotolu==1)
						{
							kyedek = ((j-gotoint)*4) + 4 ;


						}
						else
							kyedek = ((j-gotoint)*4) - 4 ;

					}
					printf("kyedek=%d\n\n", kyedek);
					printf("%c %c %c %c\n",hexdata[kyedek],hexdata[kyedek+1],hexdata[kyedek+2],hexdata[kyedek+3]);
				}
				/**** 2 ile baslayanlarin sonu ****/
			}
			if(hexdata[k+2]=='3')
			{
				/**** 3 ile baslayanlar ****/
				if((hexdata[k+3]=='E')||(hexdata[k+3]=='F'))
				{
					printf("ADDLW\n");
					
					
					literal = hextodec(hexdata[k],hexdata[k+1]);
					Working_register = Working_register + literal;
					
					if(Working_register == 0)
					{
						tobinary2(bank01[3].value);
						binary1[5] = '1';
						
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);
					}
					
					if(Working_register > 15)
					{
						tobinary2(bank01[3].value);
						binary1[6] = '1';
						binary1[5] = '0';
						
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);
					}
					
					if(Working_register >= 256)
					{
						tobinary2(bank01[3].value);
						binary1[7] = '1';
						binary1[5] = '0';
						
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);
						
						Working_register = Working_register - 256; 
					}
					kyedek = k;
					
				}
				if(hexdata[k+3]=='9')
				{
					printf("ANDLW\n");
					
					///////////////////////////////////////       ANDLW           ///////////////////////////////
					
					tobinary2(Working_register);
					
					for(j=0;j<8;j++)
						binary2[j] = binary1[j];
					
					literal = hextodec(hexdata[k],hexdata[k+1]);
					
					tobinary2(literal);
					
					
					for(j=0;j<8;j++)
					{
						
						if((binary1[j]=='1')&&(binary2[j]=='1'))
						{
							bin3[j] = '1';
						}
						else
						{
							bin3[j] = '0';
						}
						
						
					}
					 
					Working_register = bintodec(bin3);

					if(Working_register == 0)
					{
						tobinary2(bank01[3].value);
						binary1[5] = '1';
						
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);
					}
					
					
					kyedek = k;
					//////////////////////////////////////        ANDLW           ///////////////////////////////
				}
				if(hexdata[k+3]=='8')
				{
					printf("IORLW\n");
					
					////////////////////////////////////         IORLW            //////////////////////////////
					
					tobinary2(Working_register);
					
					for(j=0;j<8;j++)
						binary2[j] = binary1[j];
					
					literal = hextodec(hexdata[k],hexdata[k+1]);
					
					tobinary2(literal);
					
					
					for(j=0;j<8;j++)
					{
						//printf("%c : %c\n",binary1[j],binary2[j]);
						if((binary1[j]=='0')&&(binary2[j]=='0'))
						{
							bin3[j] = '0';
						}
						else
						{
							bin3[j] = '1';
						}
						//printf("%c",bin3[j]);
						
					}
					Working_register = bintodec(bin3);

					if(Working_register == 0)
					{
						tobinary2(bank01[3].value);
						binary1[5] = '1';
						
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);
					}

					kyedek = k;
					////////////////////////////////////         IORLW            //////////////////////////////
				}
				if((hexdata[k+3]=='0')||(hexdata[k+3]=='1')||(hexdata[k+3]=='2')||(hexdata[k+3]=='3'))
				{
					printf("MOVLW\n");
					literal = hextodec(hexdata[k],hexdata[k+1]);
					Working_register = literal;
					kyedek = k;
					
				}
				if((hexdata[k+3]=='4')||(hexdata[k+3]=='5')||(hexdata[k+3]=='6')||(hexdata[k+3]=='7'))
				{
					printf("RETLW\n");
					kyedek = k;
				}
				if((hexdata[k+3]=='C')||(hexdata[k+3]=='D'))
				{
					printf("SUBLW\n");
					
					literal = hextodec(hexdata[k],hexdata[k+1]);
					Working_register = literal - Working_register;

					tobinary2(bank01[3].value);
					
					if(Working_register < 0)
					{
						binary1[7] = '1';
						Working_register = Working_register + 256; 
					}
					if(Working_register == 0)
					{
						binary1[5] = '1';
					}
					if(Working_register > 15)
					{
						binary1[6] = '1';
					}
					
					bank01[3].value = bintodec(binary1);
					bank01[131].value = bintodec(binary1);
					bank23[3].value = bintodec(binary1);
					bank23[131].value = bintodec(binary1);

					kyedek = k;
				}
				if(hexdata[k+3]=='A')
				{
					printf("XORLW\n");
					
					/////////////////////////////            XORLW            ///////////////////////
					
					tobinary2(Working_register);
					
					for(j=0;j<8;j++)
						binary2[j] = binary1[j];
					
					literal = hextodec(hexdata[k],hexdata[k+1]);
					
					tobinary2(literal);
					
					
					for(j=0;j<8;j++)
					{
						//printf("%c : %c\n",binary1[j],binary2[j]);
						if(binary1[j]==binary2[j])
						{
							bin3[j] = '0';
						}
						else
						{
							bin3[j] = '1';
						}
						//printf("%c",bin3[j]);
						
					}
					Working_register = bintodec(bin3);
					
					
					if(Working_register == 0)
					{
						tobinary2(bank01[3].value);
						binary1[5] = '1';
						
						bank01[3].value = bintodec(binary1);
						bank01[131].value = bintodec(binary1);
						bank23[3].value = bintodec(binary1);
						bank23[131].value = bintodec(binary1);
					}
					

					kyedek = k;
					////////////////////////////             XORLW            ///////////////////////
				}
				

				/*** 3 ile baslayanlarin sonu ****/	
			}


	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	
	p = kyedek;
	p = p + 4;

	//for(j=0;j<9999999;j++)
	//	for(int serdar=0;serdar<10;serdar++);
}

void callerfunc(int k)
{
 	if(!initiated) {initregs();}
 	if (sz==0) {hex(); }
	hexfunc(k);
}


simulator::simulator( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "simulator" );
    setEnabled( TRUE );
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, sizePolicy().hasHeightForWidth() ) );
    setMinimumSize( QSize( 600, 450 ) );
    setMaximumSize( QSize( 600, 450 ) );
    setBackgroundOrigin( QDialog::WidgetOrigin );
    QFont f( font() );
    f.setPointSize( 11 );
    setFont( f ); 
    ispoweron=false;
    
    kLed10 = new KLed( this, "kLed10" );
    kLed10->setGeometry( QRect( 190, 40, 16, 16 ) );
    kLed10->setState( KLed::Off );
    kLed10->setColor( QColor( 255, 0, 0 ) );

    kLed5 = new KLed( this, "kLed5" );
    kLed5->setGeometry( QRect( 170, 40, 16, 16 ) );
    kLed5->setState( KLed::Off );
    kLed5->setColor( QColor( 255, 0, 0 ) );

    kLed8 = new KLed( this, "kLed8" );
    kLed8->setGeometry( QRect( 150, 40, 16, 16 ) );
    kLed8->setState( KLed::Off );
    kLed8->setColor( QColor( 255, 0, 0 ) );

    kLed6 = new KLed( this, "kLed6" );
    kLed6->setGeometry( QRect( 130, 40, 16, 16 ) );
    kLed6->setState( KLed::Off );
    kLed6->setColor( QColor( 255, 0, 0 ) );

    kLed4 = new KLed( this, "kLed4" );
    kLed4->setGeometry( QRect( 110, 40, 16, 16 ) );
    kLed4->setState( KLed::Off );
    kLed4->setColor( QColor( 255, 0, 0 ) );

    kLed7 = new KLed( this, "kLed7" );
    kLed7->setGeometry( QRect( 90, 40, 16, 16 ) );
    kLed7->setState( KLed::Off );
    kLed7->setColor( QColor( 255, 0, 0 ) );

    kLed3 = new KLed( this, "kLed3" );
    kLed3->setGeometry( QRect( 70, 40, 16, 16 ) );
    kLed3->setState( KLed::Off );
    kLed3->setColor( QColor( 255, 0, 0 ) );

    kLed9 = new KLed( this, "kLed9" );
    kLed9->setGeometry( QRect( 50, 40, 16, 16 ) );
    kLed9->setState( KLed::Off );
    kLed9->setColor( QColor( 255, 0, 0 ) );

    kLed12 = new KLed( this, "kLed12" );
    kLed12->setGeometry( QRect( 30, 120, 20, 20 ) );
 kLed12->setState( KLed::Off );
    kLed12->setColor( QColor( 255, 0, 0 ) );
    
    kLed14 = new KLed( this, "kLed14" );
    kLed14->setGeometry( QRect( 70, 120, 20, 20 ) );
 kLed14->setState( KLed::Off );
    kLed14->setColor( QColor( 255, 0, 0 ) );

    kLed13 = new KLed( this, "kLed13" );
    kLed13->setGeometry( QRect( 30, 140, 20, 20 ) );
 kLed13->setState( KLed::Off );
    kLed13->setColor( QColor( 255, 0, 0 ) );

    kLed15 = new KLed( this, "kLed15" );
    kLed15->setGeometry( QRect( 50, 140, 20, 20 ) );
 kLed15->setState( KLed::Off );
    kLed15->setColor( QColor( 255, 0, 0 ) );

    kLed16 = new KLed( this, "kLed16" );
    kLed16->setGeometry( QRect( 70, 140, 20, 20 ) );
 kLed16->setState( KLed::Off );
    kLed16->setColor( QColor( 255, 0, 0 ) );

    kLed21 = new KLed( this, "kLed21" );
    kLed21->setGeometry( QRect( 70, 160, 20, 20 ) );
 kLed21->setState( KLed::Off );
    kLed21->setColor( QColor( 255, 0, 0 ) );

    kLed20 = new KLed( this, "kLed20" );
    kLed20->setGeometry( QRect( 70, 180, 20, 20 ) );
 kLed20->setState( KLed::Off );
    kLed20->setColor( QColor( 255, 0, 0 ) );

    kLed17 = new KLed( this, "kLed17" );
    kLed17->setGeometry( QRect( 30, 160, 20, 20 ) );
 kLed17->setState( KLed::Off );
    kLed17->setColor( QColor( 255, 0, 0 ) );

    kLed18 = new KLed( this, "kLed18" );
    kLed18->setGeometry( QRect( 30, 180, 20, 20 ) );
 kLed18->setState( KLed::Off );
    kLed18->setColor( QColor( 255, 0, 0 ) );

    kLed22 = new KLed( this, "kLed22" );
    kLed22->setGeometry( QRect( 100, 180, 20, 20 ) );
 kLed22->setState( KLed::Off );
    kLed22->setColor( QColor( 255, 0, 0 ) );

    kLed19 = new KLed( this, "kLed19" );
    kLed19->setGeometry( QRect( 50, 180, 20, 20 ) );
 kLed19->setState( KLed::Off );
    kLed19->setColor( QColor( 255, 0, 0 ) );

    kLed12_2 = new KLed( this, "kLed12_2" );
    kLed12_2->setGeometry( QRect( 130, 120, 20, 20 ) );
 kLed12_2->setState( KLed::Off );
    kLed12_2->setColor( QColor( 255, 0, 0 ) );

    kLed14_2 = new KLed( this, "kLed14_2" );
    kLed14_2->setGeometry( QRect( 170, 120, 20, 20 ) );
 kLed14_2->setState( KLed::Off );
    kLed14_2->setColor( QColor( 255, 0, 0 ) );

    kLed22_2 = new KLed( this, "kLed22_2" );
    kLed22_2->setGeometry( QRect( 200, 180, 20, 20 ) );
 kLed22_2->setState( KLed::Off );
    kLed22_2->setColor( QColor( 255, 0, 0 ) );

    kLed18_2 = new KLed( this, "kLed18_2" );
    kLed18_2->setGeometry( QRect( 130, 180, 20, 20 ) );
 kLed18_2->setState( KLed::Off );
    kLed18_2->setColor( QColor( 255, 0, 0 ) );

    kLed13_2 = new KLed( this, "kLed13_2" );
    kLed13_2->setGeometry( QRect( 130, 140, 20, 20 ) );
 kLed13_2->setState( KLed::Off );
    kLed13_2->setColor( QColor( 255, 0, 0 ) );

    kLed19_2 = new KLed( this, "kLed19_2" );
    kLed19_2->setGeometry( QRect( 150, 180, 20, 20 ) );
 kLed19_2->setState( KLed::Off );
    kLed19_2->setColor( QColor( 255, 0, 0 ) );

    kLed16_2 = new KLed( this, "kLed16_2" );
    kLed16_2->setGeometry( QRect( 170, 140, 20, 20 ) );
 kLed16_2->setState( KLed::Off );
    kLed16_2->setColor( QColor( 255, 0, 0 ) );

    kLed21_2 = new KLed( this, "kLed21_2" );
    kLed21_2->setGeometry( QRect( 170, 160, 20, 20 ) );
 kLed21_2->setState( KLed::Off );
    kLed21_2->setColor( QColor( 255, 0, 0 ) );

    kLed17_2 = new KLed( this, "kLed17_2" );
    kLed17_2->setGeometry( QRect( 130, 160, 20, 20 ) );
 kLed17_2->setState( KLed::Off );
    kLed17_2->setColor( QColor( 255, 0, 0 ) );

    kLed15_2 = new KLed( this, "kLed15_2" );
    kLed15_2->setGeometry( QRect( 150, 140, 20, 20 ) );
 kLed15_2->setState( KLed::Off );
    kLed15_2->setColor( QColor( 255, 0, 0 ) );

    kLed20_2 = new KLed( this, "kLed20_2" );
    kLed20_2->setGeometry( QRect( 170, 180, 20, 20 ) );
 kLed20_2->setState( KLed::Off );
    kLed20_2->setColor( QColor( 255, 0, 0 ) );

    QWidget* privateLayoutWidget = new QWidget( this, "layout19" );
    privateLayoutWidget->setGeometry( QRect( 240, 290, 342, 148 ) );
    layout19 = new QVBoxLayout( privateLayoutWidget, 11, 6, "layout19"); 

    layout15 = new QHBoxLayout( 0, 0, 6, "layout15"); 

    pushButton1 = new QPushButton( privateLayoutWidget, "pushButton1" );
    layout15->addWidget( pushButton1 );

    pushButton2 = new QPushButton( privateLayoutWidget, "pushButton2" );
    layout15->addWidget( pushButton2 );

    pushButton3 = new QPushButton( privateLayoutWidget, "pushButton3" );
    layout15->addWidget( pushButton3 );

    pushButton4 = new QPushButton( privateLayoutWidget, "pushButton4" );
    layout15->addWidget( pushButton4 );
    layout19->addLayout( layout15 );

    layout16 = new QHBoxLayout( 0, 0, 6, "layout16"); 

    pushButton5 = new QPushButton( privateLayoutWidget, "pushButton5" );
    layout16->addWidget( pushButton5 );

    pushButton6 = new QPushButton( privateLayoutWidget, "pushButton6" );
    layout16->addWidget( pushButton6 );

    pushButton7 = new QPushButton( privateLayoutWidget, "pushButton7" );
    layout16->addWidget( pushButton7 );

    pushButton18 = new QPushButton( privateLayoutWidget, "pushButton18" );
    layout16->addWidget( pushButton18 );
    layout19->addLayout( layout16 );

    layout17 = new QHBoxLayout( 0, 0, 6, "layout17"); 

    pushButton19 = new QPushButton( privateLayoutWidget, "pushButton19" );
    layout17->addWidget( pushButton19 );

    pushButton20 = new QPushButton( privateLayoutWidget, "pushButton20" );
    layout17->addWidget( pushButton20 );

    pushButton21 = new QPushButton( privateLayoutWidget, "pushButton21" );
    layout17->addWidget( pushButton21 );

    pushButton22 = new QPushButton( privateLayoutWidget, "pushButton22" );
    layout17->addWidget( pushButton22 );
    layout19->addLayout( layout17 );

    layout18 = new QHBoxLayout( 0, 0, 6, "layout18"); 

    pushButton23 = new QPushButton( privateLayoutWidget, "pushButton23" );
    layout18->addWidget( pushButton23 );

    pushButton24 = new QPushButton( privateLayoutWidget, "pushButton24" );
    layout18->addWidget( pushButton24 );

    pushButton25 = new QPushButton( privateLayoutWidget, "pushButton25" );
    layout18->addWidget( pushButton25 );

    pushButton26 = new QPushButton( privateLayoutWidget, "pushButton26" );
    layout18->addWidget( pushButton26 );
    layout19->addLayout( layout18 );

    
    textEdit1 = new QTextEdit( this, "textEdit1" );
    textEdit1->setEnabled( FALSE );
    textEdit1->setGeometry( QRect( 354, 40, 220, 140 ) );
    QFont textEdit1_font(  textEdit1->font() );
    textEdit1_font.setFamily( "Terminal" );
    textEdit1->setFont( textEdit1_font ); 
    textEdit1->setWordWrap( QTextEdit::WidgetWidth );

    kLed22_3 = new KLed( this, "kLed22_3" );
    kLed22_3->setGeometry( QRect( 300, 180, 20, 20 ) );
 kLed22_3->setState( KLed::Off );
    kLed22_3->setColor( QColor( 255, 0, 0 ) );

    kLed12_3 = new KLed( this, "kLed12_3" );
    kLed12_3->setGeometry( QRect( 230, 120, 20, 20 ) );
 kLed12_3->setState( KLed::Off );
    kLed12_3->setColor( QColor( 255, 0, 0 ) );

    kLed18_3 = new KLed( this, "kLed18_3" );
    kLed18_3->setGeometry( QRect( 230, 180, 20, 20 ) );
 kLed18_3->setState( KLed::Off );
    kLed18_3->setColor( QColor( 255, 0, 0 ) );

    kLed13_3 = new KLed( this, "kLed13_3" );
    kLed13_3->setGeometry( QRect( 230, 140, 20, 20 ) );
 kLed13_3->setState( KLed::Off );
    kLed13_3->setColor( QColor( 255, 0, 0 ) );

    kLed16_3 = new KLed( this, "kLed16_3" );
    kLed16_3->setGeometry( QRect( 270, 140, 20, 20 ) );
 kLed16_3->setState( KLed::Off );
    kLed16_3->setColor( QColor( 255, 0, 0 ) );

    kLed17_3 = new KLed( this, "kLed17_3" );
    kLed17_3->setGeometry( QRect( 230, 160, 20, 20 ) );
 kLed17_3->setState( KLed::Off );
    kLed17_3->setColor( QColor( 255, 0, 0 ) );

    kLed14_3 = new KLed( this, "kLed14_3" );
    kLed14_3->setGeometry( QRect( 270, 120, 20, 20 ) );
 kLed14_3->setState( KLed::Off );
    kLed14_3->setColor( QColor( 255, 0, 0 ) );

    kLed21_3 = new KLed( this, "kLed21_3" );
    kLed21_3->setGeometry( QRect( 270, 160, 20, 20 ) );
 kLed21_3->setState( KLed::Off );
    kLed21_3->setColor( QColor( 255, 0, 0 ) );

    kLed20_3 = new KLed( this, "kLed20_3" );
    kLed20_3->setGeometry( QRect( 270, 180, 20, 20 ) );
 kLed20_3->setState( KLed::Off );
    kLed20_3->setColor( QColor( 255, 0, 0 ) );

    kLed15_3 = new KLed( this, "kLed15_3" );
    kLed15_3->setGeometry( QRect( 250, 140, 20, 20 ) );
 kLed15_3->setState( KLed::Off );
    kLed15_3->setColor( QColor( 255, 0, 0 ) );

    kLed19_3 = new KLed( this, "kLed19_3" );
    kLed19_3->setGeometry( QRect( 250, 180, 20, 20 ) );
 kLed19_3->setState( KLed::Off );
    kLed19_3->setColor( QColor( 255, 0, 0 ) );

    kLed51 = new KLed( this, "kLed51" );
    kLed51->setGeometry( QRect( 30, 100, 20, 20 ) );
 kLed51->setState( KLed::Off );
    kLed51->setColor( QColor( 255, 0, 0 ) );

    kLed52 = new KLed( this, "kLed52" );
    kLed52->setGeometry( QRect( 50, 100, 20, 20 ) );
 kLed52->setState( KLed::Off );
    kLed52->setColor( QColor( 255, 0, 0 ) );

    kLed53 = new KLed( this, "kLed53" );
    kLed53->setGeometry( QRect( 70, 100, 20, 20 ) );
 kLed53->setState( KLed::Off );
    kLed53->setColor( QColor( 255, 0, 0 ) );

    kLed54 = new KLed( this, "kLed54" );
    kLed54->setGeometry( QRect( 130, 100, 20, 20 ) );
 kLed54->setState( KLed::Off );
    kLed54->setColor( QColor( 255, 0, 0 ) );

    kLed55 = new KLed( this, "kLed55" );
    kLed55->setGeometry( QRect( 150, 100, 20, 20 ) );
 kLed55->setState( KLed::Off );
    kLed55->setColor( QColor( 255, 0, 0 ) );

    kLed56 = new KLed( this, "kLed56" );
    kLed56->setGeometry( QRect( 170, 100, 20, 20 ) );
 kLed56->setState( KLed::Off );
    kLed56->setColor( QColor( 255, 0, 0 ) );

    kLed57 = new KLed( this, "kLed57" );
    kLed57->setGeometry( QRect( 230, 100, 20, 20 ) );
 kLed57->setState( KLed::Off );
    kLed57->setColor( QColor( 255, 0, 0 ) );

    kLed58 = new KLed( this, "kLed58" );
    kLed58->setGeometry( QRect( 250, 100, 20, 20 ) );
 kLed58->setState( KLed::Off );
    kLed58->setColor( QColor( 255, 0, 0 ) );

    kLed59 = new KLed( this, "kLed59" );
    kLed59->setGeometry( QRect( 270, 100, 20, 20 ) );
 kLed59->setState( KLed::Off );
    kLed59->setColor( QColor( 255, 0, 0 ) );
    
    power = new QPushButton( this, "power" );
    power->setGeometry( QRect( 70, 360, 80, 30 ) ); 

    languageChange();
    resize( QSize(600, 450).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    
    // signals and slots connections
    connect( power, SIGNAL(released() ), this, SLOT(poweron()));
 }

/*
 *  Destroys the object and frees any allocated resources
 */
simulator::~simulator()
{
    sz=0;
    destroy(true, true);
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void simulator::languageChange()
{
    setCaption( tr( "PicSim Simulation Window" ) );
    pushButton1->setText( tr( "01" ) );
    pushButton2->setText( tr( "02" ) );
    pushButton3->setText( tr( "03" ) );
    pushButton4->setText( tr( "04" ) );
    pushButton5->setText( tr( "05" ) );
    pushButton6->setText( tr( "06" ) );
    pushButton7->setText( tr( "07" ) );
    pushButton18->setText( tr( "08" ) );
    pushButton19->setText( tr( "09" ) );
    pushButton20->setText( tr( "10" ) );
    pushButton21->setText( tr( "11" ) );
    pushButton22->setText( tr( "12" ) );
    pushButton23->setText( tr( "13" ) );
    pushButton24->setText( tr( "14" ) );   
    pushButton25->setText( tr( "15" ) );
    pushButton26->setText( tr( "16" ) );
    textEdit1->setText( QString::null );
    power->setText( tr( "power" ) );
}

void simulator::poweron()
{  
    ispoweron=~ispoweron;
    //power->setDown(true);
    if(ispoweron) startsimulation();
}


void simulator::leds()
{
tobinary( porta, bank01[5].value);

tobinary(portd, bank01[8].value);


//printf("ledportd=%d\n", bank01[8].value);
 //   if (bank01[136].value == 0) // portd as output

if(bank01[5].value)
{
	if(porta[2]=='1')
	{	
		//printf("ledporta2=%c\n", porta[2]);
		//printf("ledportd0=%c\n", portd[0]);
		if(portd[7]=='0')
		{
			kLed9->off();
		}

		
		if(portd[6]=='0')
		{
			kLed3->off();
		}

		    
		if(portd[5]=='0')
		{
			kLed7->off();
		}

		    
		if(portd[4]=='0')
		{
			kLed4->off();
		}

		    
		if(portd[3]=='0')
		{
			kLed6->off();
		}
		    
		if(portd[2]=='0')
		{
			kLed8->off();
		}
		    
		if(portd[1]=='0')
		{
			kLed5->off();

		}
		    
		if(portd[0]=='0')
		{
			kLed10->off();
		}



		if(portd[7]=='1')
		{
			kLed9->on();
			ispoweron = false;
		}

		
		if(portd[6]=='1')
		{
			kLed3->on();
			ispoweron = false;
		}

		    
		if(portd[5]=='1')
		{
			kLed7->on();
			ispoweron = false;
		}

		    
		if(portd[4]=='1')
		{
			kLed4->on();
			ispoweron = false;
		}

		    
		if(portd[3]=='1')
		{
			kLed6->on();
			ispoweron = false;
		}
		    
		if(portd[2]=='1')
		{
			kLed8->on();
			ispoweron = false;
		}
		    
		if(portd[1]=='1')
		{	
			kLed5->on();
			ispoweron = false;
			
		}
		    
		if(portd[0]=='1')
		{
			//printf("ufuk\n");
			kLed10->on();
			ispoweron = false;
			
		}

	
	}
 
	else
	{
		kLed9->off();
		kLed3->off();
		kLed7->off();
		kLed4->off();
		kLed6->off();
		kLed8->off();
		kLed5->off();
		kLed10->off();
	}

}
//ispoweron = false;



}



void simulator::sevensegment()
{

tobinary(porte , bank01[9].value);
tobinary(portd, bank01[8].value);
 
if(bank01[9].value)
{
printf("porte=%d\n", bank01[9].value);	
	if(porte[0]=='1')
	{
//�ce s�sn
		if(portd[0]=='0')
		{
			kLed13_3->off();
			kLed15_3->off();
			kLed16_3->off();
		}
		
		if(portd[1]=='0')
		{
			kLed13_3->off();
			kLed12_3->off();
			kLed57->off();
		}
		
		
		if(portd[2]=='0')
		{
			kLed13_3->off();
			kLed17_3->off();
			kLed18_3->off();
		}
		
		
		if(portd[3]=='0')
		{
			kLed18_3->off();
			kLed19_3->off();
			kLed20_3->off();
		}
		
		
		if(portd[4]=='0')
		{
			kLed20_3->off();
			kLed21_3->off();
			kLed16_3->off();
		}
		
		
		if(portd[5]=='0')
		{
			kLed16_3->off();
			kLed14_3->off();
			kLed59->off();
		}
		
		if(portd[6]=='0')
		{

			kLed59->off();
			kLed58->off();
			kLed57->off();
		}

		
		if(portd[7]=='0')
		{
			kLed22_3->off();
		}

//imdi yanacaklar yansn
		if(portd[0]=='1')
		{
			kLed13_3->on();
			kLed15_3->on();
			kLed16_3->on();
		}
		
		if(portd[1]=='1')
		{
			kLed13_3->on();
			kLed12_3->on();
			kLed57->on();
		}
		
		
		if(portd[2]=='1')
		{
			kLed13_3->on();
			kLed17_3->on();
			kLed18_3->on();
		}
		
		
		if(portd[3]=='1')
		{
			kLed18_3->on();
			kLed19_3->on();
			kLed20_3->on();
		}
		
		
		if(portd[4]=='1')
		{
			kLed20_3->on();
			kLed21_3->on();
			kLed16_3->on();
		}
		
		
		if(portd[5]=='1')
		{
			kLed16_3->on();
			kLed14_3->on();
			kLed59->on();
		}
		
		if(portd[6]=='1')
		{

			kLed59->on();
			kLed58->on();
			kLed57->on();
		}

		
		if(portd[7]=='1')
		{
			kLed22_3->on();
		}
	
	if(bank01[8].value)
	ispoweron=false;
		//en sagdaki display
	
	}

	else
	{
	kLed12_3->off();
	kLed13_3->off();
	kLed14_3->off();
	kLed15_3->off();
	kLed16_3->off();
	kLed17_3->off();
	kLed18_3->off();
	kLed19_3->off();
	kLed20_3->off();
	kLed21_3->off();
	kLed22_3->off();
	kLed57->off();
	kLed58->off();
	kLed59->off();
		
	}


	if(porte[1]=='1')
	{
//�ce s�ecekler s�sn

		if(portd[0]=='0')
		{
			kLed13_2->off();
			kLed15_2->off();
			kLed16_2->off();
		}
		
	
		
		if(portd[1]=='0')
		{
			kLed13_2->off();
			kLed12_2->off();
			kLed54->off();
		}
		
	
		
		if(portd[2]=='0')
		{
			kLed13_2->off();
			kLed17_2->off();
			kLed18_2->off();
		}
		
		
		if(portd[3]=='0')
		{
			kLed18_2->off();
			kLed19_2->off();
			kLed20_2->off();
		}
		
	
		
		if(portd[4]=='0')
		{
			kLed20_2->off();
			kLed21_2->off();
			kLed16_2->off();
		}
		
		
		
		if(portd[5]=='0')
		{
			kLed16_2->off();
			kLed14_2->off();
			kLed56->off();
		}
		
	
		if(portd[6]=='0')
		{
			kLed54->off();
			kLed55->off();
			kLed56->off();
		}
		if(portd[7]=='1')
		{
			kLed22_2->off();
		}

//sonra yanacaklar yansn
		if(portd[0]=='1')
		{
			kLed13_2->on();
			kLed15_2->on();
			kLed16_2->on();
		}
		
	
		
		if(portd[1]=='1')
		{
			kLed13_2->on();
			kLed12_2->on();
			kLed54->on();
		}
		
	
		
		if(portd[2]=='1')
		{
			kLed13_2->on();
			kLed17_2->on();
			kLed18_2->on();
		}
		
		
		if(portd[3]=='1')
		{
			kLed18_2->on();
			kLed19_2->on();
			kLed20_2->on();
		}
		
	
		
		if(portd[4]=='1')
		{
			kLed20_2->on();
			kLed21_2->on();
			kLed16_2->on();
		}
		
		
		
		if(portd[5]=='1')
		{
			kLed16_2->on();
			kLed14_2->on();
			kLed56->on();
		}
		
	
		if(portd[6]=='1')
		{
			kLed54->on();
			kLed55->on();
			kLed56->on();
		}
		if(portd[7]=='1')
		{
			kLed22_2->on();
		}
		
		if(bank01[8].value)
	ispoweron=false;	
		//ortadaki display
	}
	
	else
	{
	kLed12_2->off();
	kLed13_2->off();
	kLed14_2->off();
	kLed15_2->off();
	kLed16_2->off();
	kLed17_2->off();
	kLed18_2->off();
	kLed19_2->off();
	kLed20_2->off();
	kLed21_2->off();
	kLed22_2->off();
	kLed54->off();
	kLed55->off();
	kLed56->off();
	
	}



	if(porte[2]=='1')
	{
	  
//�ce s�ecekler s�sn		
		if(portd[0]=='0')
		{
		
			kLed13->off();
			kLed15->off();
			kLed16->off();	
		}		
		if(portd[1]=='0')
		{
			kLed13->off();
			kLed12->off();
			kLed51->off();
		}
	
		
		if(portd[2]=='0')
		{
			kLed13->off();
			kLed17->off();
			kLed18->off();
		}
		
	
		if(portd[3]=='0')
		{
			kLed18->off();
			kLed19->off();
			kLed20->off();
		}
		
	
		if(portd[4]=='0')
		{
			kLed20->off();
			kLed21->off();
			kLed16->off();
		}
		

		
		if(portd[5]=='0')
		{
			kLed16->off();
			kLed14->off();
			kLed53->off();
		}

		
		if(portd[6]=='0')
		{
			kLed53->off();
			kLed52->off();
			kLed51->off();
		}
		

		
		if(portd[7]=='0')
		{
			kLed22->off();
		}

//sonra yanacaklar yansn
		if(portd[0]=='1')
		{
			kLed13->on();
			kLed15->on();
			kLed16->on();
		}
		
		
		
		if(portd[1]=='1')
		{
			kLed13->on();
			kLed12->on();
			kLed51->on();
		}
	
		
		if(portd[2]=='1')
		{
			kLed13->on();
			kLed17->on();
			kLed18->on();
		}
		
	
		if(portd[3]=='1')
		{
			kLed18->on();
			kLed19->on();
			kLed20->on();
		}
		
	
		if(portd[4]=='1')
		{
			kLed20->on();
			kLed21->on();
			kLed16->on();
		}
		

		
		if(portd[5]=='1')
		{
			kLed14->on();
			kLed53->on();
			kLed16->on();
		}

		
		if(portd[6]=='1')
		{
			kLed53->on();
			kLed52->on();
			kLed51->on();
		}
		

		
		if(portd[7]=='1')
		{
			kLed22->on();
		}
		
	//if(bank01[8].value)
	//ispoweron=false;

		//en soldaki display
	}

	else
	{
	kLed12->off();
	kLed13->off();
	kLed14->off();
	kLed15->off();
	kLed16->off();
	kLed17->off();
	kLed18->off();
	kLed19->off();
	kLed20->off();
	kLed21->off();
	kLed22->off();
	kLed51->off();
	kLed52->off();
	kLed53->off();
	
	}
}
//ispoweron=false;

}

void simulator::startsimulation()
{
 while(ispoweron)
    {
    callerfunc(p);
    leds();
    sevensegment();
    }

}
